diff --git a/gcc/ada/rtsfind.ads b/gcc/ada/rtsfind.ads
index 65c64090371..24aca2cf6b6 100644
--- a/gcc/ada/rtsfind.ads
+++ b/gcc/ada/rtsfind.ads
@@ -189,7 +189,6 @@ package Rtsfind is
       --  Children of Interfaces
 
       Interfaces_C,
-      Interfaces_Packed_Decimal,
 
       --  Children of Interfaces.C
 
@@ -205,7 +204,6 @@ package Rtsfind is
       System_Address_To_Access_Conversions,
       System_Arith_64,
       System_Arith_128,
-      System_AST_Handling,
       System_Assertions,
       System_Atomic_Operations,
       System_Atomic_Primitives,
@@ -257,9 +255,6 @@ package Rtsfind is
       System_Fat_LFlt,
       System_Fat_LLF,
       System_Fat_SFlt,
-      System_Fat_VAX_D_Float,
-      System_Fat_VAX_F_Float,
-      System_Fat_VAX_G_Float,
       System_Finalization_Masters,
       System_Finalization_Root,
       System_Fore_Decimal_32,
@@ -288,14 +283,12 @@ package Rtsfind is
       System_Img_LLLI,
       System_Img_LLU,
       System_Img_LLLU,
-      System_Img_Name,
       System_Img_Uns,
       System_Img_WChar,
       System_Interrupts,
       System_Long_Long_Float_Expon,
       System_Machine_Code,
       System_Mantissa,
-      System_Memcop,
       System_Memory,
       System_Multiprocessors,
       System_Pack_03,
@@ -420,10 +413,7 @@ package Rtsfind is
       System_Pack_127,
       System_Parameters,
       System_Partition_Interface,
-      System_Pool_32_Global,
       System_Pool_Global,
-      System_Pool_Empty,
-      System_Pool_Local,
       System_Pool_Size,
       System_Put_Images,
       System_Put_Task_Images,
@@ -440,7 +430,6 @@ package Rtsfind is
       System_Stream_Attributes,
       System_Task_Info,
       System_Tasking,
-      System_Threads,
       System_Unsigned_Types,
       System_Val_Bool,
       System_Val_Char,
@@ -461,7 +450,6 @@ package Rtsfind is
       System_Val_LLLI,
       System_Val_LLU,
       System_Val_LLLU,
-      System_Val_Name,
       System_Val_Uns,
       System_Val_WChar,
       System_Version_Control,
@@ -475,7 +463,6 @@ package Rtsfind is
       System_Wid_LLLI,
       System_Wid_LLU,
       System_Wid_LLLU,
-      System_Wid_Name,
       System_Wid_Uns,
       System_Wid_WChar,
       System_WWd_Char,
@@ -484,7 +471,7 @@ package Rtsfind is
 
       --  Children of System.Atomic_Operations
 
-       System_Atomic_Operations_Test_And_Set,
+      System_Atomic_Operations_Test_And_Set,
 
       --  Children of System.Dim
 
@@ -561,17 +548,13 @@ package Rtsfind is
 
      RE_Set_Deadline,                    -- Ada.Dispatching.EDF
 
-     RE_Code_Loc,                        -- Ada.Exceptions
      RE_Exception_Id,                    -- Ada.Exceptions
-     RE_Exception_Identity,              -- Ada.Exceptions
      RE_Exception_Information,           -- Ada.Exceptions
      RE_Exception_Message,               -- Ada.Exceptions
      RE_Exception_Name_Simple,           -- Ada.Exceptions
      RE_Exception_Occurrence,            -- Ada.Exceptions
-     RE_Exception_Occurrence_Access,     -- Ada.Exceptions
      RE_Null_Id,                         -- Ada.Exceptions
      RE_Null_Occurrence,                 -- Ada.Exceptions
-     RE_Poll,                            -- Ada.Exceptions
      RE_Raise_Exception,                 -- Ada.Exceptions
      RE_Raise_Exception_Always,          -- Ada.Exceptions
      RE_Raise_From_Controlled_Operation, -- Ada.Exceptions
@@ -596,7 +579,7 @@ package Rtsfind is
      RE_Names,                           -- Ada.Interrupts.Names
 
      RE_Clock,                           -- Ada.Real_Time
-     RE_Clock_Time,                      -- Ada.Real_Time
+     RE_Clock_Time,                      -- Ada.Real_Time [used by GNATprove]
      RE_Time_Span,                       -- Ada.Real_Time
      RE_Time_Span_Zero,                  -- Ada.Real_Time
      RO_RT_Time,                         -- Ada.Real_Time
@@ -612,8 +595,6 @@ package Rtsfind is
      RE_Stream_Element_Array,            -- Ada.Streams
      RE_Stream_Element_Offset,           -- Ada.Streams
 
-     RE_Stream_Access,                   -- Ada.Streams.Stream_IO
-
      RO_SU_Super_String,                 -- Ada.Strings.Superbounded
 
      RO_WI_Super_String,                 -- Ada.Strings.Wide_Superbounded
@@ -628,8 +609,6 @@ package Rtsfind is
 
      RE_Buffer_Type,                     -- Ada.Strings.Text_Buffers.Unbounded
      RE_Get,                             -- Ada.Strings.Text_Buffers.Unbounded
-     RE_Wide_Get,                        -- Ada.Strings.Text_Buffers.Unbounded
-     RE_Wide_Wide_Get,                   -- Ada.Strings.Text_Buffers.Unbounded
 
      RE_Wait_For_Release,                -- Ada.Synchronous_Barriers
 
@@ -641,7 +620,6 @@ package Rtsfind is
      RE_Address_Array,                   -- Ada.Tags
      RE_Addr_Ptr,                        -- Ada.Tags
      RE_Base_Address,                    -- Ada.Tags
-     RE_Check_Interface_Conversion,      -- Ada.Tags
      RE_Check_TSD,                       -- Ada.Tags
      RE_Cstring_Ptr,                     -- Ada.Tags
      RE_CW_Membership,                   -- Ada.Tags
@@ -656,13 +634,11 @@ package Rtsfind is
      RE_External_Tag,                    -- Ada.Tags
      RO_TA_External_Tag,                 -- Ada.Tags
      RE_Get_Access_Level,                -- Ada.Tags
-     RE_Get_Alignment,                   -- Ada.Tags
      RE_Get_Entry_Index,                 -- Ada.Tags
      RE_Get_Offset_Index,                -- Ada.Tags
      RE_Get_Prim_Op_Kind,                -- Ada.Tags
      RE_Get_Tagged_Kind,                 -- Ada.Tags
      RE_HT_Link,                         -- Ada.Tags
-     RE_Idepth,                          -- Ada.Tags
      RE_Interfaces_Array,                -- Ada.Tags
      RE_Interfaces_Table,                -- Ada.Tags
      RE_Interface_Data,                  -- Ada.Tags
@@ -675,8 +651,6 @@ package Rtsfind is
      RE_No_Dispatch_Table_Wrapper,       -- Ada.Tags
      RE_No_Tag,                          -- Ada.Tags
      RE_NDT_Prims_Ptr,                   -- Ada.Tags
-     RE_NDT_TSD,                         -- Ada.Tags
-     RE_Num_Prims,                       -- Ada.Tags
      RE_Object_Specific_Data,            -- Ada.Tags
      RE_Offset_To_Top,                   -- Ada.Tags
      RE_Offset_To_Top_Ptr,               -- Ada.Tags
@@ -699,11 +673,9 @@ package Rtsfind is
      RE_Primary_DT,                      -- Ada.Tags
      RE_Signature,                       -- Ada.Tags
      RE_SSD,                             -- Ada.Tags
-     RE_TSD,                             -- Ada.Tags
      RE_Type_Specific_Data,              -- Ada.Tags
      RE_Register_Interface_Offset,       -- Ada.Tags
      RE_Register_Tag,                    -- Ada.Tags
-     RE_Register_TSD,                    -- Ada.Tags
      RE_Transportable,                   -- Ada.Tags
      RE_Secondary_DT,                    -- Ada.Tags
      RE_Secondary_Tag,                   -- Ada.Tags
@@ -749,7 +721,6 @@ package Rtsfind is
 
      RE_Stream_T,                        -- CUDA.Driver_Types
 
-     RE_Fatbin_Wrapper,                  -- CUDA.Internal
      RE_Launch_Kernel,                   -- CUDA.Internal
      RE_Pop_Call_Configuration,          -- CUDA.Internal
      RE_Push_Call_Configuration,         -- CUDA.Internal
@@ -772,19 +743,14 @@ package Rtsfind is
 
      RO_IC_Unsigned,                     -- Interfaces.C
 
-     RE_Chars_Ptr,                       -- Interfaces.C.Strings
-     RE_New_Char_Array,                  -- Interfaces.C.Strings
-
      RE_Address,                         -- System
      RE_Any_Priority,                    -- System
      RE_Bit_Order,                       -- System
      RE_Default_Priority,                -- System
      RE_High_Order_First,                -- System
      RE_Interrupt_Priority,              -- System
-     RE_Lib_Stop,                        -- System
      RE_Low_Order_First,                 -- System
      RE_Max_Base_Digits,                 -- System
-     RE_Max_Priority,                    -- System
      RE_Null_Address,                    -- System
      RE_Priority,                        -- System
 
@@ -802,8 +768,6 @@ package Rtsfind is
      RE_Subtract_With_Ovflo_Check128,    -- System.Arith_128
      RE_Scaled_Divide128,                -- System.Arith_128
 
-     RE_Create_AST_Handler,              -- System.AST_Handling
-
      RE_Assert_Failure,                  -- System.Assertions
      RE_Raise_Assert_Failure,            -- System.Assertions
 
@@ -824,9 +788,6 @@ package Rtsfind is
      RE_Atomic_Test_And_Set,           -- System.Atomic_Operations.Test_And_Set
 
      RE_AST_Handler,                     -- System.Aux_DEC
-     RE_Import_Address,                  -- System.Aux_DEC
-     RE_Import_Value,                    -- System.Aux_DEC
-     RE_No_AST_Handler,                  -- System.Aux_DEC
      RE_Type_Class,                      -- System.Aux_DEC
      RE_Type_Class_Enumeration,          -- System.Aux_DEC
      RE_Type_Class_Integer,              -- System.Aux_DEC
@@ -954,15 +915,6 @@ package Rtsfind is
 
      RE_Attr_Long_Long_Float,            -- System.Fat_LLF
 
-     RE_Attr_VAX_D_Float,                -- System.Fat_VAX_D_Float
-     RE_Fat_VAX_D,                       -- System.Fat_VAX_D_Float
-
-     RE_Attr_VAX_F_Float,                -- System.Fat_VAX_F_Float
-     RE_Fat_VAX_F,                       -- System.Fat_VAX_F_Float
-
-     RE_Attr_VAX_G_Float,                -- System.Fat_VAX_G_Float
-     RE_Fat_VAX_G,                       -- System.Fat_VAX_G_Float
-
      RE_Add_Offset_To_Address,           -- System.Finalization_Masters
      RE_Attach,                          -- System.Finalization_Masters
      RE_Base_Pool,                       -- System.Finalization_Masters
@@ -970,10 +922,8 @@ package Rtsfind is
      RE_Finalization_Master_Ptr,         -- System.Finalization_Masters
      RE_Set_Base_Pool,                   -- System.Finalization_Masters
      RE_Set_Finalize_Address,            -- System.Finalization_Masters
-     RE_Set_Is_Heterogeneous,            -- System.Finalization_Masters
 
      RE_Root_Controlled,                 -- System.Finalization_Root
-     RE_Root_Controlled_Ptr,             -- System.Finalization_Root
 
      RE_Fore_Decimal32,                  -- System.Fore_Decimal_32
 
@@ -1649,9 +1599,7 @@ package Rtsfind is
      RE_Set_127,                         -- System.Pack_127
 
      RE_Adjust_Storage_Size,             -- System.Parameters
-     RE_Default_Secondary_Stack_Size,    -- System.Parameters
      RE_Default_Stack_Size,              -- System.Parameters
-     RE_Garbage_Collected,               -- System.Parameters
      RE_Size_Type,                       -- System.Parameters
      RE_Unspecified_Size,                -- System.Parameters
 
@@ -1677,8 +1625,6 @@ package Rtsfind is
 
      RE_Global_Pool_Object,              -- System.Pool_Global
 
-     RE_Global_Pool_32_Object,           -- System.Pool_32_Global
-
      RE_Stack_Bounded_Pool,              -- System.Pool_Size
 
      RE_Put_Image_Integer,               -- System.Put_Images
@@ -1744,11 +1690,8 @@ package Rtsfind is
      RE_Set_Result,                      -- System.Partition_Interface
      RE_Register_Obj_Receiving_Stub,     -- System.Partition_Interface
      RE_Register_Pkg_Receiving_Stub,     -- System.Partition_Interface
-     RE_Is_Nil,                          -- System.Partition_Interface
-     RE_Entity_Ptr,                      -- System.Partition_Interface
      RE_Entity_Of,                       -- System.Partition_Interface
      RE_Inc_Usage,                       -- System.Partition_Interface
-     RE_Set_Ref,                         -- System.Partition_Interface
      RE_Make_Ref,                        -- System.Partition_Interface
      RE_Get_Local_Address,               -- System.Partition_Interface
      RE_Get_Reference,                   -- System.Partition_Interface
@@ -1881,8 +1824,6 @@ package Rtsfind is
      RE_Deallocate_Any_Controlled,       -- System.Storage_Pools.Subpools
      RE_Header_Size_With_Padding,        -- System.Storage_Pools.Subpools
      RE_Root_Storage_Pool_With_Subpools, -- System.Storage_Pools.Subpools
-     RE_Root_Subpool,                    -- System.Storage_Pools.Subpools
-     RE_Subpool_Handle,                  -- System.Storage_Pools.Subpools
 
      RE_I_AD,                            -- System.Stream_Attributes
      RE_I_AS,                            -- System.Stream_Attributes
@@ -2006,7 +1947,6 @@ package Rtsfind is
      RE_Simple_Mode,                     -- System.Tasking
      RE_Terminate_Mode,                  -- System.Tasking
      RE_Delay_Mode,                      -- System.Tasking
-     RE_Entry_Index,                     -- System.Tasking
      RE_Task_Entry_Index,                -- System.Tasking
      RE_Self,                            -- System.Tasking
 
@@ -2244,17 +2184,13 @@ package Rtsfind is
 
      RE_Set_Deadline                     => Ada_Dispatching_EDF,
 
-     RE_Code_Loc                         => Ada_Exceptions,
      RE_Exception_Id                     => Ada_Exceptions,
-     RE_Exception_Identity               => Ada_Exceptions,
      RE_Exception_Information            => Ada_Exceptions,
      RE_Exception_Message                => Ada_Exceptions,
      RE_Exception_Name_Simple            => Ada_Exceptions,
      RE_Exception_Occurrence             => Ada_Exceptions,
-     RE_Exception_Occurrence_Access      => Ada_Exceptions,
      RE_Null_Id                          => Ada_Exceptions,
      RE_Null_Occurrence                  => Ada_Exceptions,
-     RE_Poll                             => Ada_Exceptions,
      RE_Raise_Exception                  => Ada_Exceptions,
      RE_Raise_Exception_Always           => Ada_Exceptions,
      RE_Raise_From_Controlled_Operation  => Ada_Exceptions,
@@ -2295,8 +2231,6 @@ package Rtsfind is
      RE_Stream_Element_Array             => Ada_Streams,
      RE_Stream_Element_Offset            => Ada_Streams,
 
-     RE_Stream_Access                    => Ada_Streams_Stream_IO,
-
      RO_SU_Super_String                  => Ada_Strings_Superbounded,
 
      RO_WI_Super_String                  => Ada_Strings_Wide_Superbounded,
@@ -2311,8 +2245,6 @@ package Rtsfind is
 
      RE_Buffer_Type                      => Ada_Strings_Text_Buffers_Unbounded,
      RE_Get                              => Ada_Strings_Text_Buffers_Unbounded,
-     RE_Wide_Get                         => Ada_Strings_Text_Buffers_Unbounded,
-     RE_Wide_Wide_Get                    => Ada_Strings_Text_Buffers_Unbounded,
 
      RE_Wait_For_Release                 => Ada_Synchronous_Barriers,
 
@@ -2324,7 +2256,6 @@ package Rtsfind is
      RE_Address_Array                    => Ada_Tags,
      RE_Addr_Ptr                         => Ada_Tags,
      RE_Base_Address                     => Ada_Tags,
-     RE_Check_Interface_Conversion       => Ada_Tags,
      RE_Check_TSD                        => Ada_Tags,
      RE_Cstring_Ptr                      => Ada_Tags,
      RE_CW_Membership                    => Ada_Tags,
@@ -2339,13 +2270,11 @@ package Rtsfind is
      RE_External_Tag                     => Ada_Tags,
      RO_TA_External_Tag                  => Ada_Tags,
      RE_Get_Access_Level                 => Ada_Tags,
-     RE_Get_Alignment                    => Ada_Tags,
      RE_Get_Entry_Index                  => Ada_Tags,
      RE_Get_Offset_Index                 => Ada_Tags,
      RE_Get_Prim_Op_Kind                 => Ada_Tags,
      RE_Get_Tagged_Kind                  => Ada_Tags,
      RE_HT_Link                          => Ada_Tags,
-     RE_Idepth                           => Ada_Tags,
      RE_Interfaces_Array                 => Ada_Tags,
      RE_Interfaces_Table                 => Ada_Tags,
      RE_Interface_Data                   => Ada_Tags,
@@ -2358,8 +2287,6 @@ package Rtsfind is
      RE_No_Dispatch_Table_Wrapper        => Ada_Tags,
      RE_No_Tag                           => Ada_Tags,
      RE_NDT_Prims_Ptr                    => Ada_Tags,
-     RE_NDT_TSD                          => Ada_Tags,
-     RE_Num_Prims                        => Ada_Tags,
      RE_Object_Specific_Data             => Ada_Tags,
      RE_Offset_To_Top                    => Ada_Tags,
      RE_Offset_To_Top_Ptr                => Ada_Tags,
@@ -2382,11 +2309,9 @@ package Rtsfind is
      RE_Primary_DT                       => Ada_Tags,
      RE_Signature                        => Ada_Tags,
      RE_SSD                              => Ada_Tags,
-     RE_TSD                              => Ada_Tags,
      RE_Type_Specific_Data               => Ada_Tags,
      RE_Register_Interface_Offset        => Ada_Tags,
      RE_Register_Tag                     => Ada_Tags,
-     RE_Register_TSD                     => Ada_Tags,
      RE_Transportable                    => Ada_Tags,
      RE_Secondary_DT                     => Ada_Tags,
      RE_Secondary_Tag                    => Ada_Tags,
@@ -2432,7 +2357,6 @@ package Rtsfind is
 
      RE_Stream_T                         => CUDA_Driver_Types,
 
-     RE_Fatbin_Wrapper                   => CUDA_Internal,
      RE_Launch_Kernel                    => CUDA_Internal,
      RE_Pop_Call_Configuration           => CUDA_Internal,
      RE_Push_Call_Configuration          => CUDA_Internal,
@@ -2455,19 +2379,14 @@ package Rtsfind is
 
      RO_IC_Unsigned                      => Interfaces_C,
 
-     RE_Chars_Ptr                        => Interfaces_C_Strings,
-     RE_New_Char_Array                   => Interfaces_C_Strings,
-
      RE_Address                          => System,
      RE_Any_Priority                     => System,
      RE_Bit_Order                        => System,
      RE_Default_Priority                 => System,
      RE_High_Order_First                 => System,
      RE_Interrupt_Priority               => System,
-     RE_Lib_Stop                         => System,
      RE_Low_Order_First                  => System,
      RE_Max_Base_Digits                  => System,
-     RE_Max_Priority                     => System,
      RE_Null_Address                     => System,
      RE_Priority                         => System,
 
@@ -2485,8 +2404,6 @@ package Rtsfind is
      RE_Subtract_With_Ovflo_Check128     => System_Arith_128,
      RE_Scaled_Divide128                 => System_Arith_128,
 
-     RE_Create_AST_Handler               => System_AST_Handling,
-
      RE_Assert_Failure                   => System_Assertions,
      RE_Raise_Assert_Failure             => System_Assertions,
 
@@ -2507,9 +2424,6 @@ package Rtsfind is
      RE_Atomic_Test_And_Set           => System_Atomic_Operations_Test_And_Set,
 
      RE_AST_Handler                      => System_Aux_DEC,
-     RE_Import_Address                   => System_Aux_DEC,
-     RE_Import_Value                     => System_Aux_DEC,
-     RE_No_AST_Handler                   => System_Aux_DEC,
      RE_Type_Class                       => System_Aux_DEC,
      RE_Type_Class_Enumeration           => System_Aux_DEC,
      RE_Type_Class_Integer               => System_Aux_DEC,
@@ -2643,15 +2557,6 @@ package Rtsfind is
 
      RE_Attr_Long_Long_Float             => System_Fat_LLF,
 
-     RE_Attr_VAX_D_Float                 => System_Fat_VAX_D_Float,
-     RE_Fat_VAX_D                        => System_Fat_VAX_D_Float,
-
-     RE_Attr_VAX_F_Float                 => System_Fat_VAX_F_Float,
-     RE_Fat_VAX_F                        => System_Fat_VAX_F_Float,
-
-     RE_Attr_VAX_G_Float                 => System_Fat_VAX_G_Float,
-     RE_Fat_VAX_G                        => System_Fat_VAX_G_Float,
-
      RE_Add_Offset_To_Address            => System_Finalization_Masters,
      RE_Attach                           => System_Finalization_Masters,
      RE_Base_Pool                        => System_Finalization_Masters,
@@ -2659,10 +2564,8 @@ package Rtsfind is
      RE_Finalization_Master_Ptr          => System_Finalization_Masters,
      RE_Set_Base_Pool                    => System_Finalization_Masters,
      RE_Set_Finalize_Address             => System_Finalization_Masters,
-     RE_Set_Is_Heterogeneous             => System_Finalization_Masters,
 
      RE_Root_Controlled                  => System_Finalization_Root,
-     RE_Root_Controlled_Ptr              => System_Finalization_Root,
 
      RE_Fore_Decimal32                   => System_Fore_Decimal_32,
 
@@ -3340,9 +3243,7 @@ package Rtsfind is
      RE_Set_127                          => System_Pack_127,
 
      RE_Adjust_Storage_Size              => System_Parameters,
-     RE_Default_Secondary_Stack_Size     => System_Parameters,
      RE_Default_Stack_Size               => System_Parameters,
-     RE_Garbage_Collected                => System_Parameters,
      RE_Size_Type                        => System_Parameters,
      RE_Unspecified_Size                 => System_Parameters,
 
@@ -3399,11 +3300,8 @@ package Rtsfind is
      RE_Set_Result                       => System_Partition_Interface,
      RE_Register_Obj_Receiving_Stub      => System_Partition_Interface,
      RE_Register_Pkg_Receiving_Stub      => System_Partition_Interface,
-     RE_Is_Nil                           => System_Partition_Interface,
-     RE_Entity_Ptr                       => System_Partition_Interface,
      RE_Entity_Of                        => System_Partition_Interface,
      RE_Inc_Usage                        => System_Partition_Interface,
-     RE_Set_Ref                          => System_Partition_Interface,
      RE_Make_Ref                         => System_Partition_Interface,
      RE_Get_Local_Address                => System_Partition_Interface,
      RE_Get_Reference                    => System_Partition_Interface,
@@ -3488,8 +3386,6 @@ package Rtsfind is
 
      RE_Global_Pool_Object               => System_Pool_Global,
 
-     RE_Global_Pool_32_Object            => System_Pool_32_Global,
-
      RE_Stack_Bounded_Pool               => System_Pool_Size,
 
      RE_Put_Image_Integer                => System_Put_Images,
@@ -3572,8 +3468,6 @@ package Rtsfind is
      RE_Deallocate_Any_Controlled        => System_Storage_Pools_Subpools,
      RE_Header_Size_With_Padding         => System_Storage_Pools_Subpools,
      RE_Root_Storage_Pool_With_Subpools  => System_Storage_Pools_Subpools,
-     RE_Root_Subpool                     => System_Storage_Pools_Subpools,
-     RE_Subpool_Handle                   => System_Storage_Pools_Subpools,
 
      RE_I_AD                             => System_Stream_Attributes,
      RE_I_AS                             => System_Stream_Attributes,
@@ -3697,7 +3591,6 @@ package Rtsfind is
      RE_Simple_Mode                      => System_Tasking,
      RE_Terminate_Mode                   => System_Tasking,
      RE_Delay_Mode                       => System_Tasking,
-     RE_Entry_Index                      => System_Tasking,
      RE_Task_Entry_Index                 => System_Tasking,
      RE_Self                             => System_Tasking,
 